#ifndef umFish40Load_H
#define umFish40Load_H
// -------------------------------------------------------------------------------------
//
// umFish40Load.H                                                 Ulrich Mller 08.09.05
//                                                                PCS1700 C++Builder 4.0
// Basisfunktionen fr die fischertechnik Interfaces :
//         Intelligent Interface und ROBO Interface
// Dynamisches Laden der umFish40.DLL
//
// -------------------------------------------------------------------------------------

#include <windows.h>

HINSTANCE rbFishLib;

// --- umFish40 Funktionsprototypen ----------------------------------------------------

typedef int    (__stdcall *TOpenInterfaceUSB) (int ifTyp, int SerialNr);
typedef int    (__stdcall *TOpenInterfaceCOM) (int ifTyp, int ComNr, int AnalogZyklen);
typedef int    (__stdcall *TCloseInterface)   (int iHandle);
typedef int    (__stdcall *TGetInput)         (int iHandle, int InputNr);
typedef int    (__stdcall *TGetInputs)        (int iHandle);
typedef int    (__stdcall *TGetAnalog)        (int iHandle, int AnalogNr);
typedef int    (__stdcall *TGetIRKey)         (int iHandle, int Code, int KeyNr);
typedef int    (__stdcall *TGetVoltage)       (int iHandle, int VoltNr);
typedef int    (__stdcall *TSetMotor)         (int iHandle, int MotNr, int Dir);
typedef int    (__stdcall *TSetMotorEx)       (int iHandle, int MotNr, int Dir,
                                               int Speed);
typedef int    (__stdcall *TGetMotors)        (int iHandle);
typedef int    (__stdcall *TSetMotors)        (int iHandle, int MotorStatus);
typedef int    (__stdcall *TSetMotorsEx)      (int iHandle, int MotorStatus,
                                               int SpeedStatus, int SpeedStatus16);
typedef int    (__stdcall *TGetModeStatus)    (int iHandle, int MotNr);
typedef int    (__stdcall *TSetModeStatus)    (int iHandle, int MotNr, int Mode);
typedef int    (__stdcall *TSetLamp)          (int iHandle, int LampNr, int OnOff);
typedef int    (__stdcall *TSetLampEx)        (int iHandle, int LampNr, int OnOff,
                                               int Power);
typedef int    (__stdcall *TRobMotor)         (int iHandle, int MotNr, int Dir,
                                               int Speed, int ICount);
typedef int    (__stdcall *TRobMotors)        (int iHandle, int MotorStatus,
                                               int SpeedStatus, int SpeedStatus16,
                                               int ModeStatus);
typedef int    (__stdcall *TGetCounter)       (int iHandle, int CounterNr);
typedef int    (__stdcall *TSetCounter)       (int iHandle, int CounterNr, int ICount);
typedef int    (__stdcall *TClearCounters)    (int iHandle);
typedef int    (__stdcall *TGetActDeviceType) (int iHandle);
typedef int    (__stdcall *TGetActDeviceSerialNr)   (int iHandle);
typedef int    (__stdcall *TGetActDeviceFirmwareNr) (int iHandle);
typedef LPCSTR (__stdcall *TGetActDeviceFirmware)   (int iHandle);
typedef LPCSTR (__stdcall *TGetActDeviceName)       (int iHandle);

// --- Konstanten ----------------------------------------------------------------------

enum ftDir {ftAus = 0, ftEin = 1, ftLinks = 1, ftRechts = 2};
enum IFTypen {ftROBO_first_USB       = 0,
              ftIntelligent_IF       = 10,
              ftIntelligent_IF_Slave = 20,
              ftROBO_IF_IIM          = 50,
              ftROBO_IF_USB          = 60,
              ftROBO_IF_COM          = 70,
              ftROBO_IF_Over_RF      = 80,
              ftROBO_IO_Extension    = 90,
              ftROBO_RF_Datalink     =110};
const int ftFehler = 0xE0000001L;

// --- Funktionen ----------------------------------------------------------------------

TOpenInterfaceUSB       rbOpenInterfaceUSB;
TOpenInterfaceCOM       rbOpenInterfaceCOM;
TCloseInterface         rbCloseInterface;
TGetInput               rbGetInput;
TGetInputs              rbGetInputs;
TGetAnalog              rbGetAnalog;
TGetIRKey               rbGetIRKey;
TGetVoltage             rbGetVoltage;
TSetMotor               rbSetMotor;
TSetMotorEx             rbSetMotorEx;
TGetMotors              rbGetMotors;
TSetMotors              rbSetMotors;
TSetMotorsEx            rbSetMotorsEx;
TGetModeStatus          rbGetModeStatus;
TSetModeStatus          rbSetModeStatus;
TSetLamp                rbSetLamp;
TSetLampEx              rbSetLampEx;
TRobMotor               rbRobMotor;
TRobMotors              rbRobMotors;
TGetCounter             rbGetCounter;
TSetCounter             rbSetCounter;
TClearCounters          rbClearCounters;
TGetActDeviceType       rbGetActDeviceType;
TGetActDeviceSerialNr   rbGetActDeviceSerialNr;
TGetActDeviceFirmwareNr rbGetActDeviceFirmwareNr;
TGetActDeviceFirmware   rbGetActDeviceFirmware;
TGetActDeviceName       rbGetActDeviceName;

// --- Laderoutine LoadFish -----------------------------------------------------------

BOOLEAN LoadFish(void) {
  rbFishLib = LoadLibrary("umFish40.DLL");
  if(!rbFishLib) return false;
  rbOpenInterfaceUSB        = (TOpenInterfaceUSB)
                              GetProcAddress(rbFishLib, "rbOpenInterfaceUSB");
  rbOpenInterfaceCOM        = (TOpenInterfaceCOM)
                              GetProcAddress(rbFishLib, "rbOpenInterfaceCOM");
  rbCloseInterface          = (TCloseInterface)
                              GetProcAddress(rbFishLib, "rbCloseInterface");
  rbGetInput                = (TGetInput)
                              GetProcAddress(rbFishLib, "rbGetInput");
  rbGetInputs               = (TGetInputs)
                              GetProcAddress(rbFishLib, "rbGetInputs");
  rbGetAnalog               = (TGetAnalog)
                              GetProcAddress(rbFishLib, "rbGetAnalog");
  rbGetIRKey                = (TGetIRKey)
                              GetProcAddress(rbFishLib, "rbGetIRKey");
  rbGetVoltage              = (TGetVoltage)
                              GetProcAddress(rbFishLib, "rbGetVoltage");
  rbSetMotor                = (TSetMotor)
                              GetProcAddress(rbFishLib, "rbSetMotor");
  rbSetMotorEx              = (TSetMotorEx)
                              GetProcAddress(rbFishLib, "rbSetMotorEx");
  rbGetMotors               = (TGetMotors)
                              GetProcAddress(rbFishLib, "rbGetMotors");
  rbSetMotors               = (TSetMotors)
                              GetProcAddress(rbFishLib, "rbSetMotors");
  rbSetMotorsEx             = (TSetMotorsEx)
                              GetProcAddress(rbFishLib, "rbSetMotorsEx");
  rbGetModeStatus           = (TGetModeStatus)
                              GetProcAddress(rbFishLib, "rbGetmodeStatus");
  rbSetModeStatus           = (TSetModeStatus)
                              GetProcAddress(rbFishLib, "rbSetModeStatus");
  rbSetLamp                 = (TSetLamp)
                              GetProcAddress(rbFishLib, "rbSetLamp");
  rbSetLampEx               = (TSetLampEx)
                              GetProcAddress(rbFishLib, "rbSetLampEx");
  rbRobMotor                = (TRobMotor)
                              GetProcAddress(rbFishLib, "rbRobMotor");
  rbRobMotors               = (TRobMotors)
                              GetProcAddress(rbFishLib, "rbRobMotors");
  rbGetCounter              = (TGetCounter)
                              GetProcAddress(rbFishLib, "rbGetCounter");
  rbSetCounter              = (TSetCounter)
                              GetProcAddress(rbFishLib, "rbSetCounter");
  rbClearCounters           = (TClearCounters)
                              GetProcAddress(rbFishLib, "rbClearCounters");
  rbGetActDeviceType        = (TGetActDeviceType)
                              GetProcAddress(rbFishLib, "rbGetActDeviceType");
  rbGetActDeviceSerialNr    = (TGetActDeviceSerialNr)
                              GetProcAddress(rbFishLib, "rbGetActDeviceSerialNr");
  rbGetActDeviceFirmwareNr  = (TGetActDeviceFirmwareNr)
                              GetProcAddress(rbFishLib, "rbGetActDeviceFirmwareNr");
  rbGetActDeviceFirmware    = (TGetActDeviceFirmware)
                              GetProcAddress(rbFishLib, "rbGetActDeviceFirmware");
  rbGetActDeviceName        = (TGetActDeviceName)
                              GetProcAddress(rbFishLib, "rbGetActDeviceName");
  return true;
}

// --- Unloadroutine FreeFish ----------------------------------------------------------
void FreeFish(void) {
  FreeLibrary(rbFishLib);
  rbFishLib = NULL;
  return;
}

#endif

